#!/usr/bin/env python
# coding: utf-8

# In[1]:


name = 'world'
print('hello ' + name + '!')


# In[2]:


a = 1
print('first cell: a = {}'.format(a))


# In[3]:


a += 1
print('second cell: a = {}'.format(a))


# In[4]:


import numpy as np
from matplotlib import pyplot
get_ipython().run_line_magic('matplotlib', 'inline')

x = np.linspace(1E-3, 2 * np.pi)

pyplot.plot(x, np.sin(x) / x)
pyplot.plot(x, np.cos(x))
pyplot.grid()


# In[5]:


from IPython.display import Latex
Latex('\\int_{-\\infty}^\\infty e^{-x²}dx = \\sqrt{\\pi}')


# In[6]:


import ipywidgets as w
from IPython.display import display

a = w.IntSlider()
b = w.IntText()
w.jslink((a, 'value'), (b, 'value'))
display(a, b)


# In[7]:


print('this code is invisible')


# In[8]:


print('this output is invisible')


# In[9]:


print('this code is below the output')


# In[10]:


print('A')
print('B')
print('C')


# In[11]:


print('A')
print('B')
print('C')


# In[12]:


d = {
    'a': 1,
    'b': 2,
    'c': 3,
    'd': 4,
    'e': 5,
}


# In[13]:


1 / 0


# In[14]:


a = {'hello': 'world!'}
a['jello']


# In[15]:


import sys

print("hello, world!", file=sys.stderr)


# In[ ]:


import time

def slow_print(str):
    time.sleep(4000)    # Simulate an expensive process
    print(str)

slow_print("hello, world!")

